var socket = io.connect();
//If user not logged, return to login page
if (localStorage.getItem("user") == null || localStorage.getItem("user") == undefined || localStorage.getItem("user") == ""){
  window.location.href = "index.html";
}
//Request initial data
socket.emit('start');
//On initial data recived, display
socket.on('SP', function(data) {
	var SP_05 = [];
	var SP_5 = [];
	for (i=0; i < data.length; i++){
		SP_05[i] = data[i].SP_PV_05;
		SP_5[i] = data[i].SP_PV_5;
	};
  	document.getElementById('c1_sp_05').value = SP_05[0];
  	document.getElementById('c1_sp_5').value = SP_5[0];
  	document.getElementById('c2_sp_05').value = SP_05[1];
  	document.getElementById('c2_sp_5').value = SP_5[1];
  	document.getElementById('c3_sp_05').value = SP_05[2];
  	document.getElementById('c3_sp_5').value = SP_5[2];
  	document.getElementById('c4_sp_05').value = SP_05[3];
  	document.getElementById('c4_sp_5').value = SP_5[3];
  	document.getElementById('c5_sp_05').value = SP_05[4];
  	document.getElementById('c5_sp_5').value = SP_5[4];
  	document.getElementById('c6_sp_05').value = SP_05[5];
  	document.getElementById('c6_sp_5').value = SP_5[5];
});
//If there is an alarm, display
socket.on('ALARMS', function(data) {
	for (i=0; i < data.length; i++){
		if (data[i].pv_05){
			document.getElementById('c'+ (i+1) +'_al_05').style.backgroundColor = "#f77979";
		}
		else {
			document.getElementById('c'+ (i+1) +'_al_05').style.backgroundColor = "white";
		}
		if (data[i].pv_5){
			document.getElementById('c'+ (i+1) +'_al_5').style.backgroundColor = "#f77979";
		}
		else {
			document.getElementById('c'+ (i+1) +'_al_5').style.backgroundColor = "white";
		}
	};
});

//Add eventlistener for the SP
window.onload=function(){
  	for (i=0;i<6;i++){
	  	document.getElementById('c'+ (i+1) +'_sp_05').addEventListener("keydown",function(e){
			if(e.keyCode===13){
		        document.activeElement.blur();
		    }
		});
		document.getElementById('c'+ (i+1) +'_sp_5').addEventListener("keydown",function(e){
			if(e.keyCode===13){
		        document.activeElement.blur();
		    }
		});
	;}
};

//SP change, send to Backend
function SP_05(counter){
	var value = document.getElementById('c'+ counter + '_sp_05').value;
	var data = {
    	counter: counter,
    	column: "SP_PV_05",
    	user: localStorage.getItem("user"),
    	value: value
  	};
	socket.emit('SP_Change', data);
}
function SP_5(counter){
	var value = document.getElementById('c'+ counter + '_sp_5').value;
	var data = {
    	counter: counter,
    	column: "SP_PV_5",
    	user: localStorage.getItem("user"),
    	value: value
  	};
	socket.emit('SP_Change', data);
}

//On logoff
function logoff(){
  window.location.href = "index.html";
  var event = {
    tag: "User",
    description: "User " + localStorage.getItem("user") + " of group "+ localStorage.getItem("group") + " has logged off.",
    user: localStorage.getItem("user"),
    value: "-",
    oldvalue: localStorage.getItem("user")
  }
  localStorage.removeItem("user");
  socket.emit('event', event);
}

//On PV recived
socket.on('COUNTER01', function(data) {
	console.log(data[0].pv_05);
  	if (data[0].pv_05 != null && data[0].pv_5 != null) {
		document.getElementById('c1_pv_05').innerHTML = data.map(function(data) {return(`<p>${data.pv_05}</p>`)});
		document.getElementById('c1_pv_5').innerHTML =  data.map(function(data) {return(`<p>${data.pv_5}</p>`)});
		if (data[0].counting){
			document.getElementById('c1_cnt').style.backgroundColor = "#a7efa7";
		}
		else{
			document.getElementById('c1_cnt').style.backgroundColor = "white";
		}
	}
	else{
		console.log ("Error PV COUNTER01");
	}
});
socket.on('COUNTER02', function(data) {
  	if (data[0].pv_05 != null && data[0].pv_5 != null) {
		document.getElementById('c2_pv_05').innerHTML = data.map(function(data) {return(`<p>${data.pv_05}</p>`)});
		document.getElementById('c2_pv_5').innerHTML =  data.map(function(data) {return(`<p>${data.pv_5}</p>`)});
		if (data[0].counting){
			document.getElementById('c2_cnt').style.backgroundColor = "#a7efa7";
		}
		else{
			document.getElementById('c2_cnt').style.backgroundColor = "white";
		}
	}
	else{
		console.log ("Error PV COUNTER02");
	}
});
socket.on('COUNTER03', function(data) {
  	if (data[0].pv_05 != null && data[0].pv_5 != null) {
		document.getElementById('c3_pv_05').innerHTML = data.map(function(data) {return(`<p>${data.pv_05}</p>`)});
		document.getElementById('c3_pv_5').innerHTML =  data.map(function(data) {return(`<p>${data.pv_5}</p>`)});
		if (data[0].counting){
			document.getElementById('c3_cnt').style.backgroundColor = "#a7efa7";
		}
		else{
			document.getElementById('c3_cnt').style.backgroundColor = "white";
		}
	}
	else{
		console.log ("Error PV COUNTER03");
	}
});
socket.on('COUNTER04', function(data) {
  	if (data[0].pv_05 != null && data[0].pv_5 != null) {
		document.getElementById('c4_pv_05').innerHTML = data.map(function(data) {return(`<p>${data.pv_05}</p>`)});
		document.getElementById('c4_pv_5').innerHTML =  data.map(function(data) {return(`<p>${data.pv_5}</p>`)});
		if (data[0].counting){
			document.getElementById('c4_cnt').style.backgroundColor = "#a7efa7";
		}
		else{
			document.getElementById('c4_cnt').style.backgroundColor = "white";
		}
	}
	else{
		console.log ("Error PV COUNTER04");
	}
});
socket.on('COUNTER05', function(data) {
  	if (data[0].pv_05 != null && data[0].pv_5 != null) {
		document.getElementById('c5_pv_05').innerHTML = data.map(function(data) {return(`<p>${data.pv_05}</p>`)});
		document.getElementById('c5_pv_5').innerHTML =  data.map(function(data) {return(`<p>${data.pv_5}</p>`)});
		if (data[0].counting){
			document.getElementById('c5_cnt').style.backgroundColor = "#a7efa7";
		}
		else{
			document.getElementById('c5_cnt').style.backgroundColor = "white";
		}
	}
	else{
		console.log ("Error PV COUNTER05");
	}
});
socket.on('COUNTER06', function(data) {
  	if (data[0].pv_05 != null && data[0].pv_5 != null) {
		document.getElementById('c6_pv_05').innerHTML = data.map(function(data) {return(`<p>${data.pv_05}</p>`)});
		document.getElementById('c6_pv_5').innerHTML =  data.map(function(data) {return(`<p>${data.pv_5}</p>`)});
		if (data[0].counting=="1"){
			document.getElementById('c6_cnt').style.backgroundColor = "#a7efa7";
		}
		else{
			document.getElementById('c6_cnt').style.backgroundColor = "white";
		}
	}
	else{
		console.log ("Error PV COUNTER06");
	}
});

//Turn onoff request
function On(counter){
	var params = {
		counter: counter
	}
	socket.emit('on', params);
	var event = {
	    tag: "C0" + counter + "_ONOFF" ,
	    description: "Counter 0"+counter+" has been turned on.",
	    user: localStorage.getItem("user"),
	    value: "1",
	    oldvalue: "0"
	}
	socket.emit('event', event); //Emit event
}
function Off(counter){
	var params = {
		counter: counter
	}
	socket.emit('off', params);
	var event = {
	    tag: "C0" + counter + "_ONOFF" ,
	    description: "Counter 0"+counter+" has been turned off.",
	    user: localStorage.getItem("user"),
	    value: "0",
	    oldvalue: "1"
	}
	socket.emit('event', event); //Emit event
}