var socket = io.connect();

//Get the history data
function getHist(){
    //Clean last data
    document.getElementById("report-data").style.display = "none";
    var alarmsRows = document.getElementById("alarms-table").getElementsByTagName('tr');
    var max = alarmsRows.length;
    for (i=max-1;i>0;i--){
        document.getElementById("alarms-table").deleteRow(i);
    }
    alarmsRows = document.getElementById("events-table").getElementsByTagName('tr');
    max = alarmsRows.length;
    for (i=max-1;i>0;i--){
        document.getElementById("events-table").deleteRow(i);
    }
    alarmsRows = document.getElementById("hist-table").getElementsByTagName('tr');
    max = alarmsRows.length;
    for (i=max-1;i>0;i--){
        document.getElementById("hist-table").deleteRow(i);
    }
    //Format date
    var date1 = $('#datetimepicker').datetimepicker().val();
    var date1 = date1.substring(3,5) + "/" + date1.substring(0,2) + date1.substring(5,20);
    var date2 = $('#datetimepicker2').datetimepicker().val();
    var date2 = date2.substring(3,5) + "/" + date2.substring(0,2) + date2.substring(5,20);
    var params = {
        date1: date1,
        date2: date2,
        filter: $( '#filter').val()
    };
    //Send the request
    socket.emit('gethist', params);
}

//Get Alarms and display
socket.on('rep-alarms', function(data) {
  var table = document.getElementById("alarms-table");
  for(var i = 0; i < data.length; i++) {
    current_row = document.createElement("tr");
    cell1 = document.createElement("td");
    text1 = document.createTextNode(data[i].DateTimeON);
    cell1.appendChild(text1);
    current_row.appendChild(cell1);
    cell2 = document.createElement("td");
    text2 = document.createTextNode(data[i].Counter);
    cell2.appendChild(text2);
    current_row.appendChild(cell2);
    cell3 = document.createElement("td");
    text3 = document.createTextNode(data[i].Description);
    cell3.appendChild(text3);
    current_row.appendChild(cell3);
    cell4 = document.createElement("td");
    text4 = document.createTextNode(data[i].DateTimeOFF);
    cell4.appendChild(text4);
    current_row.appendChild(cell4);
    table.appendChild(current_row);
  }
  document.getElementById("report-data").style.display = "block";
});

//Get Events and display
socket.on('rep-events', function(data) {
    var table = document.getElementById("events-table");
    for(var i = 0; i < data.length; i++) {
        current_row = document.createElement("tr");
        cell1 = document.createElement("td");
        text1 = document.createTextNode(data[i].DateTime);
        cell1.appendChild(text1);
        current_row.appendChild(cell1);
        cell2 = document.createElement("td");
        text2 = document.createTextNode(data[i].Tag);
        cell2.appendChild(text2);
        current_row.appendChild(cell2);
        cell3 = document.createElement("td");
        text3 = document.createTextNode(data[i].Description);
        cell3.appendChild(text3);
        current_row.appendChild(cell3);
        cell4 = document.createElement("td");
        text4 = document.createTextNode(data[i].Username);
        cell4.appendChild(text4);
        current_row.appendChild(cell4);
        cell5 = document.createElement("td");
        text5 = document.createTextNode(data[i].Value);
        cell5.appendChild(text5);
        current_row.appendChild(cell5);
        cell6 = document.createElement("td");
        text6 = document.createTextNode(data[i].OldValue);
        cell6.appendChild(text6);
        current_row.appendChild(cell6);
        table.appendChild(current_row);
    }
});

//Get History Data and display
socket.on('rep-hist', function(data) {
    var table = document.getElementById("hist-table");
    for(var i = 0; i < data.length; i++) {
        current_row = document.createElement("tr");
        cell1 = document.createElement("td");
        text1 = document.createTextNode(data[i].DateTime);
        cell1.appendChild(text1);
        current_row.appendChild(cell1);
        cell2 = document.createElement("td");
        text2 = document.createTextNode(data[i].Counter);
        cell2.appendChild(text2);
        current_row.appendChild(cell2);
        cell3 = document.createElement("td");
        text3 = document.createTextNode(data[i].PV_05);
        cell3.appendChild(text3);
        current_row.appendChild(cell3);
        cell4 = document.createElement("td");
        text4 = document.createTextNode(data[i].PV_5);
        cell4.appendChild(text4);
        current_row.appendChild(cell4);
        cell5 = document.createElement("td");
        text5 = document.createTextNode(data[i].Counting);
        cell5.appendChild(text5);
        current_row.appendChild(cell5);
        table.appendChild(current_row);
    }
});

//Log off
function logoff(){
  window.location.href = "index.html";
  var event = {
    tag: "User",
    description: "User " + localStorage.getItem("user") + " of group "+ localStorage.getItem("group") + " has logged off.",
    user: localStorage.getItem("user"),
    value: "-",
    oldvalue: localStorage.getItem("user")
  }
  localStorage.removeItem("user");
  socket.emit('event', event);
}

//Initialization
$(document).ready(function() {
    document.getElementById("report-data").style.display = "none";
    var d = new Date();
    var day = d.getDate();
    var month = (d.getMonth() +1);
    var hours = (d.getHours()-1);
    var hours2 = d.getHours();
    var minutes = d.getMinutes();
    var seconds = d.getSeconds();
    if (day<10){day = "0" + day};
    if (month<10){month = "0" + month};
    if (hours<10){hours = "0" + hours};
    if (minutes<10){minutes = "0" + minutes};
    if (seconds<10){seconds = "0" + seconds};
    var date = day + "/" + month+"/"+ d.getFullYear() + " " + hours2 + ":" + minutes +":" + seconds;
    var date2 = day + "/" + month+"/"+ d.getFullYear() + " " + hours + ":" + minutes +":" + seconds;
    $('#datetimepicker').datetimepicker({
        format: 'DD/MM/YYYY HH:mm:ss'
    }).val(date2) ;
    $('#datetimepicker2').datetimepicker({
        format: 'DD/MM/YYYY HH:mm:ss'
    }).val(date);
});