var express = require('express');
var app = express();
var server = require('http').Server(app);
var io = require('socket.io')(server);
var moment = require('moment');

app.use(express.static('public'));

/**************SQL**************/
var sql = require('mssql');
var config = {
    user: 'sa',
    password: 'tfm',
    server: 'WIN-F49HC88EGKU', 
    database: 'TFM' 
};
/**************INITIALITZATION**************/
var user;
var COUNTERS_SP = [];
var COUNTERS_PV = [];
var COUNTERS_ALARMS = [];
for (i=0; i<6;i++){
	COUNTERS_SP [i] = {
		SP_PV_05: 0,
		SP_PV_5: 0
	};
	COUNTERS_PV [i] = {
		pv_05: 0,
		pv_5: 0,
  		counting: 0
	};
	COUNTERS_ALARMS [i] = {
		pv_05: 0,
		pv_5: 0
	};
}
sql.close();
sql.connect(config, function (err) {
    if (err) console.log(err);
    var request = new sql.Request();
    request.query("SELECT Counter, SP_PV_05, SP_PV_5 FROM [TFM].[dbo].[003_SP]", function (err, recordset) {
    	if (recordset.recordset.length >= 1) {
    		for (i=0 ; i< recordset.recordset.length; i++) {
				COUNTERS_SP[i] = {
				  SP_PV_05: recordset.recordset[i].SP_PV_05,
				  SP_PV_5: recordset.recordset[i].SP_PV_5
				};
			};
    	};
        if (err) console.log(err);
    });
});

/**************ALARMS**************/
function checkAlarms (){
	var counter = 0;
	for (i=0; i<COUNTERS_PV.length; i++){
		if (COUNTERS_PV[i].pv_05 > COUNTERS_SP[i].SP_PV_05){ //Check if PV > SP particles 0,5
			if (COUNTERS_ALARMS[i].pv_05 == 0){ //If there was no alarm, set
				COUNTERS_ALARMS[i].pv_05 = 1;
				counter = i+1;
				io.emit('ALARMS', COUNTERS_ALARMS);
				sql.close();
				sql.connect(config, function (err) { //Save the alarm to SQL
				    if (err) console.log(err);
				    var request = new sql.Request();
				    request.query("INSERT INTO [TFM].[dbo].[004_Alarms] ([DateTimeON], [Counter], [Description], [Type]) VALUES ('"+ getTime() +"','COUNTER0"+counter+"','Alarm High Counter 0"+counter+" PV 0,5 µm','Hi_05')", function (err, recordset) {
				        if (err) console.log(err);   
				    });
				});
			}
		}
		else {
			if (COUNTERS_ALARMS[i].pv_05 == 1){ //If there was a alarm, reset
				COUNTERS_ALARMS[i].pv_05 = 0;
				io.emit('ALARMS', COUNTERS_ALARMS);
				counter = i+1;
				sql.close();
				sql.connect(config, function (err) { //Update the return date of the alarm in the SQL
				    if (err) console.log(err);
				    var request = new sql.Request();
				    request.query("UPDATE [TFM].[dbo].[004_Alarms] set DateTimeOFF = '"+ getTime() +"' where Id = (SELECT MAX (Id) FROM [TFM].[dbo].[004_Alarms] where Counter = 'Counter0"+counter+"' and Type = 'Hi_05')", function (err, recordset) {
				        if (err) console.log(err);   
				    });
				});
			}
		}

		if (COUNTERS_PV[i].pv_5 > COUNTERS_SP[i].SP_PV_5){ //Check if PV > SP particles 0,5
			if (COUNTERS_ALARMS[i].pv_5 == 0){ //If there was no alarm, set
				COUNTERS_ALARMS[i].pv_5 = 1;
				counter = i+1;
				io.emit('ALARMS', COUNTERS_ALARMS);
				sql.close();
				sql.connect(config, function (err) { //Save the alarm to SQL
				    if (err) console.log(err);
				    var request = new sql.Request();
				    request.query("INSERT INTO [TFM].[dbo].[004_Alarms] ([DateTimeON], [Counter], [Description], [Type]) VALUES ('"+ getTime() +"','COUNTER0"+counter+"','Alarm High Counter 0"+counter+" PV 5 µm','Hi_5')", function (err, recordset) {
				        if (err) console.log(err);   
				    });
				});
			}
		}
		else {
			if (COUNTERS_ALARMS[i].pv_5 == 1){ //If there was a alarm, reset
				COUNTERS_ALARMS[i].pv_5 = 0;
				counter = i+1;
				io.emit('ALARMS', COUNTERS_ALARMS);
				sql.close();
				sql.connect(config, function (err) { //Update the return date of the alarm in the SQL
				    if (err) console.log(err);
				    var request = new sql.Request();
				    request.query("UPDATE [TFM].[dbo].[004_Alarms] set DateTimeOFF = '"+ getTime() +"' where Id = (SELECT MAX (Id) FROM [TFM].[dbo].[004_Alarms] where Counter = 'Counter0"+counter+"' and Type = 'Hi_5')", function (err, recordset) {
				        if (err) console.log(err);   
				    });
				});
			}
		}
	}
}
setInterval(checkAlarms, 2000); //Time interval of the script checkAlarmstime in ms

/**************SOCKET**************/
io.on('connection', function(socket) {
	console.log('Client connected with sockets'); //When a client connect

	//Login Request
	socket.on('credentials', function(data) {
	    sql.close();
		sql.connect(config, function (err) { //Check if user and password are correct
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("SELECT Username, Password, GroupUsers FROM [TFM].[dbo].[001_Users] WHERE Username = '"+data.user + "'", function (err, recordset) {
		    	if (recordset.recordset.length >= 1) { //Check if user exists
		    		var password = recordset.recordset[0].Password;
					var userinfo = {
					  user: recordset.recordset[0].Username,
					  group: recordset.recordset[0].GroupUsers
					};
		    	}
		    	else { //Wrong user, return void
		    		var password = "";
		    		var userinfo = {
					  	user: "",
					  	group: ""
					};
		    	}
		        if (err) console.log(err); 
		        if (userinfo.user == data.user && password == data.password){ //Check if password is correct
		        	user= userinfo.user;
		        	socket.emit('userinfo', userinfo);
		        }
		        else{
		        	var password = "";
		    		var userinfo = {
					  	user: "",
					  	group: ""
					};
		        	socket.emit('userinfo', userinfo);
		        }
		    });
		});
  	});

  	//Start values request
  	socket.on('start', function() {
		socket.emit('SP', COUNTERS_SP);
		socket.emit('ALARMS', COUNTERS_ALARMS);
  	});

  	//Get alarms request
  	socket.on('getalarms', function() {
  		var data = [];
		sql.close();
		sql.connect(config, function (err) { //Select last 50 alarms in SQL
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("SELECT TOP 50 DateTimeON, Counter, Description, DateTimeOFF FROM [TFM].[dbo].[004_Alarms] order by Id desc", function (err, recordset) {
		    	data = recordset.recordset;
		    	for (i=0; i<data.length; i++){ //Date format
		    		data[i].DateTimeON = moment(data[i].DateTimeON).format('DD/MM/YYYY HH:mm:ss');
		    		console.log(data[i].DateTimeOFF)
		    		if (data[i].DateTimeOFF!= null){
		    			data[i].DateTimeOFF = moment(data[i].DateTimeOFF).format('DD/MM/YYYY HH:mm:ss');
		    		}
		    		else{
		    			data[i].DateTimeOFF = "Not returned";
		    		}
		    	}
		    	socket.emit('alarms-history', data);
		    });
		});
	});

  	//Get events request
	socket.on('getevents', function() {
  		var data = [];
		sql.close();
		sql.connect(config, function (err) {//Select last 50 events in SQL
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("SELECT TOP 50 DateTime, Tag, Description, Username, Value, OldValue FROM [TFM].[dbo].[005_Events] order by Id desc", function (err, recordset) {
		    	data = recordset.recordset;
		    	for (i=0; i<data.length; i++){ //Date format
		    		data[i].DateTime = moment(data[i].DateTime).format('DD/MM/YYYY HH:mm:ss');
		    	}
		    	socket.emit('events-history', data);
		    });
		});
	});

	//Get history data
	socket.on('gethist', function(data) {
		sql.close();
		sql.connect(config, function (err) {
		    if (err) console.log(err);
		    var filter ="";
		    var filterevents = "";
		    if (data.filter != "All"){ //Filter of the query if a counter selected
		    	filter = " AND Counter = '" + data.filter + "' ";
		    	filterevents = " AND Tag like 'C0" + data.filter.substring(8,9) + "%' ";
		    }
		    //Alarms query
		    var alarms = [];
		    var request1 = new sql.Request(); 
		    request1.query("SELECT DateTimeON, Counter, Description, DateTimeOFF FROM [TFM].[dbo].[004_Alarms] WHERE DatetimeON >= '"+ data.date1 + "' and  DatetimeON <= '"+ data.date2 + "' "+filter+" order by Id desc", function (err, recordset1) {
		    	alarms = recordset1.recordset;
		    	for (i=0; i<alarms.length; i++){
		    		alarms[i].DateTimeON = moment(alarms[i].DateTimeON).format('DD/MM/YYYY HH:mm:ss');
		    		if (alarms[i].DateTimeOFF!= null){
		    			alarms[i].DateTimeOFF = moment(alarms[i].DateTimeOFF).format('DD/MM/YYYY HH:mm:ss');
		    		}
		    		else{
		    			alarms[i].DateTimeOFF = "Not returned";
		    		}
		    	}
		    	socket.emit('rep-alarms', alarms);
		    });
		    //Events query
			var events = [];
		    var request2 = new sql.Request(); 
		    request2.query("SELECT DateTime, Tag, Description, Username, Value, OldValue FROM [TFM].[dbo].[005_Events] WHERE Datetime >= '"+ data.date1 + "' and  Datetime <= '"+ data.date2 + "' "+filterevents+" order by Id desc", function (err, recordset2) {
		    	events = recordset2.recordset;
		    	for (i=0; i<events.length; i++){
		    		events[i].DateTime = moment(events[i].DateTime).format('DD/MM/YYYY HH:mm:ss');
		    	}
		    	socket.emit('rep-events', events);
		    });
			//History data query
			var hist = [];
		    if (err) console.log(err);
		    var request3 = new sql.Request();
		    request3.query("SELECT DateTime, Counter, PV_05, PV_5, Counting FROM [TFM].[dbo].[002_PV] WHERE Datetime >= '"+ data.date1 + "' and  Datetime <= '"+ data.date2 + "' "+filter+" order by Id desc", function (err, recordset3) {
		    	hist = recordset3.recordset;
		    	for (i=0; i<hist.length; i++){
		    		hist[i].DateTime = moment(hist[i].DateTime).format('DD/MM/YYYY HH:mm:ss');
		    	}
		    	socket.emit('rep-hist', hist);
		    });
		});
  	});

  	//SP change
   	socket.on('SP_Change', function(data) {
		sql.close();
		sql.connect(config, function (err) { //Update the SP to the SQL
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("UPDATE [TFM].[dbo].[003_SP] SET "+ data.column + " = " + data.value + " WHERE Counter = 'COUNTER0"+ data.counter +"';", function (err, recordset) {
		        if (err) console.log(err);   
		    });
			//Event of the change value
			var oldvalue = 0;
			var tag = "";
			var type = "";
			if (data.column =="SP_PV_05"){ 
				tag = "C0"+data.counter + "_SP_05";
				type = "0,5 µm"
				oldvalue = COUNTERS_SP[data.counter-1].SP_PV_05; //Save old value
				COUNTERS_SP [data.counter - 1].SP_PV_05 = data.value; //Set new value
			}
			if (data.column =="SP_PV_5"){
				tag = "C0"+data.counter + "_SP_05";
				type = "5 µm"
				oldvalue = COUNTERS_SP[data.counter-1].SP_PV_05; //Save old value
				COUNTERS_SP [data.counter - 1].SP_PV_5 = data.value; //Set new value
			}
			var event = { 
			    tag: tag,
			    description: "The SP value of particles of "+type+" has been modified.",
			    user:data.user,
			    value: data.value,
			    oldvalue: oldvalue
			}
		
		    var request = new sql.Request();
		    request.query("INSERT [TFM].[dbo].[005_Events] ([Datetime], [Tag], [Description], [Username], [Value], [OldValue]) VALUES('"+ getTime()+"','"+ event.tag + "','"+ event.description + "','"+ event.user + "','"+ event.value + "','"+ event.oldvalue + "');", function (err, recordset) {
		        if (err) console.log(err);   
		    });
		});
	});

	//Event request
	socket.on('event', function(data) {
		sql.close();
		sql.connect(config, function (err) { //Send the event to SQL
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("INSERT [TFM].[dbo].[005_Events] ([Datetime], [Tag], [Description], [Username], [Value], [OldValue]) VALUES('"+ getTime()+"','"+ data.tag + "','"+ data.description + "','"+ data.user + "','"+ data.value + "','"+ data.oldvalue + "');", function (err, recordset) {
		        if (err) console.log(err);   
		    });
		});
	});

	//Turn ON the counter request
	socket.on('on', function(data) {
		var topic = "COUNTER0"+data.counter+"_ONOFF";
		client.publish(topic, "1"); //Publish to MQTT broker
	});

	//Turn OFF the counter request
	socket.on('off', function(data) {
		var topic = "COUNTER0"+data.counter+"_ONOFF";
		client.publish(topic, "0"); //Publish to MQTT broker
	});
});

/**************MQTT**************/
var mqtt = require("mqtt");
var client = mqtt.connect("mqtt://ec2-52-15-100-254.us-east-2.compute.amazonaws.com:1883");

//On MQTTconnected
client.on("connect", function () { //Subscribe to the MQTT topics
    client.subscribe("COUNTER01");
    client.subscribe("COUNTER02");
    client.subscribe("COUNTER03");
    client.subscribe("COUNTER04");
	client.subscribe("COUNTER05");
    client.subscribe("COUNTER06");
    console.log("Connected to Broker MQTT");
});

//On MQTT message recived
client.on("message", function (topic, message) {
	var data = JSON.parse(message);
	if (topic == "COUNTER01"){
		var COUNTER01 = [{
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		}];
		COUNTERS_PV[0] = { //Save the data locally
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		};
		io.emit('COUNTER01', COUNTER01); //Send data to front-end
		sql.close();
		sql.connect(config, function (err) { //Save data to SQL
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("INSERT INTO [TFM].[dbo].[002_PV] ([DateTime], [COUNTER], [PV_05], [PV_5], [Counting]) VALUES ('"+ getTime() +"','COUNTER01','"+ Number(data.pv_05)+"','"+ Number(data.pv_5)+"','"+ Number(data.counting)+"')", function (err, recordset) {
		        if (err) console.log(err);   
		    });
		});
	}

	else if  (topic == "COUNTER02"){
		var COUNTER02 = [{
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		}];
		COUNTERS_PV[1] = {
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		};
		io.emit('COUNTER02', COUNTER02);
		sql.close();
		sql.connect(config, function (err) {
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("INSERT INTO [TFM].[dbo].[002_PV] ([DateTime], [COUNTER], [PV_05], [PV_5], [Counting]) VALUES ('"+ getTime() +"','COUNTER02','"+ Number(data.pv_05)+"','"+ Number(data.pv_5)+"','"+ Number(data.counting)+"')", function (err, recordset) {
		        if (err) console.log(err);   
		    });
		});
	}

	else if  (topic == "COUNTER03"){
		var COUNTER03 = [{
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		}];
		COUNTERS_PV[2] = {
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		};
		io.emit('COUNTER03', COUNTER03);
		sql.close();
		sql.connect(config, function (err) {
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("INSERT INTO [TFM].[dbo].[002_PV] ([DateTime], [COUNTER], [PV_05], [PV_5], [Counting]) VALUES ('"+ getTime() +"','COUNTER03','"+ Number(data.pv_05)+"','"+ Number(data.pv_5)+"','"+ Number(data.counting)+"')", function (err, recordset) {
		        if (err) console.log(err);  
		    });
		});
	}
	else if  (topic == "COUNTER04"){
		var COUNTER04 = [{
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		}];
		COUNTERS_PV[3] = {
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		};
		io.emit('COUNTER04', COUNTER04);
		sql.close();
		sql.connect(config, function (err) {
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("INSERT INTO [TFM].[dbo].[002_PV] ([DateTime], [COUNTER], [PV_05], [PV_5], [Counting]) VALUES ('"+ getTime() +"','COUNTER04','"+ Number(data.pv_05)+"','"+ Number(data.pv_5)+"','"+ Number(data.counting)+"')", function (err, recordset) {
		        if (err) console.log(err);   
		    });
		});
	}
	else if  (topic == "COUNTER05"){
		var COUNTER05 = [{
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		}];
		COUNTERS_PV[4] = {
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		};
		io.emit('COUNTER05', COUNTER05);
		sql.close();
		sql.connect(config, function (err) {
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("INSERT INTO [TFM].[dbo].[002_PV] ([DateTime], [COUNTER], [PV_05], [PV_5], [Counting]) VALUES ('"+ getTime() +"','COUNTER05','"+ Number(data.pv_05)+"','"+ Number(data.pv_5)+"','"+ Number(data.counting)+"')", function (err, recordset) {
		        if (err) console.log(err); 
		    });
		});
	}
	else if  (topic == "COUNTER06"){
		var COUNTER06 = [{
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		}];
		COUNTERS_PV[5] = {
  			pv_05: data.pv_05,
  			pv_5: data.pv_5,
  			counting: data.counting
		};
		io.emit('COUNTER06', COUNTER06);
		sql.close();
		sql.connect(config, function (err) {
		    if (err) console.log(err);
		    var request = new sql.Request();
		    request.query("INSERT INTO [TFM].[dbo].[002_PV] ([DateTime], [COUNTER], [PV_05], [PV_5], [Counting]) VALUES ('"+ getTime() +"','COUNTER06','"+ Number(data.pv_05)+"','"+ Number(data.pv_5)+"','"+ Number(data.counting)+"')", function (err, recordset) {
		        if (err) console.log(err); 
		    });
		});
	}
});

/**************TOOLS**************/
function getTime(){
	var date = new Date();
    date = date.getTime();
    var datestring = moment().add(1, 'hours').format('MM/DD/YYYY HH:mm:ss');
    return datestring;
}

/**************PUBLISH**************/
server.listen(80, function() {
	console.log('Server running in http://localhost:80');
});